﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace howto_fibonacci_word
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btnGo_Click(object sender, EventArgs e)
        {
            int num_words = int.Parse(txtN.Text);

            // List sub-words.
            lstS.Items.Clear();
            for (int i = 0; i < num_words; i++)
            {
                lstS.Items.Add(FiboS(i));
            }

            // List words.
            lstWords.Items.Clear();
            for (int i = 0; i < num_words; i++)
            {
                lstWords.Items.Add(Fibo(i).ToString() +
                    ": " + FiboWord(i));
            }
        }

        // Calculate the nth Fibonacci sub-word.
        private string FiboS(int n)
        {
            if (n == 0) return "0";
            if (n == 1) return "01";
            string s2 = "0";        // s - 2
            string s1 = "01";       // s - 1 
            string s0 = "010";      // s (Initially s = 2.)
            for (int i = 2; i < n; i++)
            {
                s0 = s1 + s2;
                s2 = s1;
                s1 = s0;
            }
            return s0;
        }

        // Calculate the nth Fibonacci word.
        private string FiboWord(int n)
        {
            // See how long it should be.
            int length = Fibo(n);
            string s2 = "0";        // s - 2
            string s1 = "01";       // s - 1 
            string s0 = "010";      // s (Initially s = 2.)
            while (s0.Length < length)
            {
                s0 = s1 + s2;
                s2 = s1;
                s1 = s0;
            }
            return s0.Substring(0, length);
        }

        // Return the nth Fibonacci number.
        private int Fibo(int n)
        {
            if (n <= 1) return n;
            int n2 = 0;         // n - 2
            int n1 = 1;         // n - 1
            int n0 = n1 + n2;   // n (Initially n = 2.)
            for (int i = 2; i < n; i++)
            {
                n2 = n1;
                n1 = n0;
                n0 = n1 + n2;
            }
            return n0;
        }
    }
}
